; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive
  
;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\include\dialogs.inc
      include \masm32\macros\macros.asm

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib

      DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD

      TranslateMessagex PROTO :DWORD
      DispatchMessagex  PROTO :DWORD
      GetMessagex       PROTO :DWORD,:DWORD,:DWORD,:DWORD

      loop_count equ 10000000

    .data?
      hWnd      dd ?
      hInstance dd ?

    .code

; 

start:
  
      mov hInstance, FUNC(GetModuleHandle,NULL)

      call main

      invoke ExitProcess,eax

; 

main proc

    Dialog "Blank Dialog", \                ; caption
           "MS Sans Serif",10, \            ; font,pointsize
            WS_OVERLAPPED or \              ; styles for
            WS_SYSMENU or DS_CENTER, \      ; dialog window
            3, \                            ; number of controls
            50,50,155,100, \                ; x y co-ordinates
            1024                            ; memory buffer size

    DlgButton "MASM",WS_TABSTOP,106,5,40,13,IDOK
    DlgButton "VC6",WS_TABSTOP,106,20,40,13,IDCANCEL
    DlgStatic "MASM32 Dialog",SS_LEFT,5,5,60,9,100

    CallModalDialog hInstance,0,DlgProc,NULL

    ret

main endp

; 

DlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD 
 
    Switch uMsg
      Case WM_INITDIALOG
        invoke SendMessage,hWin,WM_SETICON,1,
                           FUNC(LoadIcon,NULL,IDI_ASTERISK)
        m2m hWnd, hWin
        return 1
      Case WM_COMMAND
        Switch wParam
          Case IDOK
          ; **************************************************
            invoke GetTickCount
            push eax

            call masm_test

            invoke GetTickCount
            pop ecx
            sub eax, ecx

            fn MessageBox,hWnd,str$(eax),"Title",MB_OK
          ; **************************************************
          Case IDCANCEL
          ; **************************************************
            invoke GetTickCount
            push eax

            call vc6_test

            invoke GetTickCount
            pop ecx
            sub eax, ecx

            fn MessageBox,hWnd,str$(eax),"Title",MB_OK
          ; **************************************************
        EndSw
      Case WM_CLOSE
        quit_dialog:
         invoke EndDialog,hWin,0
    EndSw

    return 0

DlgProc endp

; 

align 4

vc6_test proc

    LOCAL cntr:DWORD
    LOCAL msg:MSG

    push ebx
    push esi
    push edi

    mov cntr, loop_count

    mov ebx, OFFSET DispatchMessagex
    mov edi, OFFSET TranslateMessagex
    mov esi, OFFSET GetMessagex

    align 4
    @@:
    ; ---------------
      lea     ecx,msg
      push    ecx
      call    edi
      lea     edx,msg
      push    edx
      call    ebx
      push    0
      push    0
      push    0
      lea     eax,msg
      push    eax
      call    esi
      test    eax,eax
    ; ---------------
    sub cntr, 1
    jnz @B

    pop edi
    pop esi
    pop ebx

    ret

vc6_test endp

; 

align 4

masm_test proc

    LOCAL cntr:DWORD
    LOCAL msg:MSG

    push ebx
    push esi
    push edi

    mov cntr, loop_count

    lea ebx, msg
    xor edi, edi
    mov esi, loop_count

    align 4
    @@:
    ; ---------------
 ;       push ebx
 ;       call TranslateMessagex
 ;       push ebx
 ;       call DispatchMessagex
 ;       push edi
 ;       push edi
 ;       push edi
 ;       push ebx
 ;       call GetMessagex
 ;       test eax, eax

    invoke TranslateMessagex,ebx
    invoke DispatchMessagex,ebx
    invoke GetMessagex,ebx,edi,edi,edi
    test eax, eax

    ; ---------------
    sub cntr, 1
    jnz @B

    pop edi
    pop esi
    pop ebx

    ret

masm_test endp

; 

align 4

TranslateMessagex proc mstruct:DWORD

    mov eax, mstruct

    mov ecx, (MSG PTR [eax]).hwnd
    mov edx, (MSG PTR [eax]).message
    mov ecx, (MSG PTR [eax]).wParam
    mov edx, (MSG PTR [eax]).message
    mov ecx, (MSG PTR [eax]).time
    mov edx, (MSG PTR [eax]).pt.x

    ret

TranslateMessagex endp

; 

align 4

DispatchMessagex proc mstruct:DWORD

    mov eax, mstruct

    mov ecx, (MSG PTR [eax]).hwnd
    mov edx, (MSG PTR [eax]).message
    mov ecx, (MSG PTR [eax]).wParam
    mov edx, (MSG PTR [eax]).message
    mov ecx, (MSG PTR [eax]).time
    mov edx, (MSG PTR [eax]).pt.x

    ret

DispatchMessagex endp

; 

align 4

GetMessagex proc mstruct:DWORD,arg1:DWORD,arg2:DWORD,arg3:DWORD

    push ebx
    push esi
    push edi

    mov eax, mstruct

    mov ecx, (MSG PTR [eax]).hwnd
    mov edx, (MSG PTR [eax]).message
    mov ecx, (MSG PTR [eax]).wParam
    mov edx, (MSG PTR [eax]).message
    mov ecx, (MSG PTR [eax]).time
    mov edx, (MSG PTR [eax]).pt.x

    mov ebx, arg1
    mov esi, arg2
    mov edi, arg3

    pop edi
    pop esi
    pop ebx

    ret

GetMessagex endp

; 

end start
